//Marinel Serban - 2018
//100 puncte
#include <fstream>
#include <cstring>
#include <cstdlib>

using namespace std;

ifstream fin("gcl.in");
ofstream fout("gcl.out");

int V[27];                  //cele 26 variabile V[0] - a, V[1] - b, ...
char instructiune[110];     //instructiunea curenta
char secv_repeat[51][110];  //secventa de instructiuni din REPETA
int contor_scrie, cerinta;

void scrie(char E[110])
{
   char x;
   while (E[5] == ' ')
	   strcpy(E + 5, E + 6);
   x = E[5];                         //variabila care trebuie afisata
   if (cerinta == 2)
      fout << x << " = " << V[x-'a'] << '\n';
   else
      contor_scrie++;
}

void expresie(char E[110])
{
   unsigned int i;
   int semn = 1, coef, val_dreapta = 0;
   i = 0;
   while (i < strlen(E))      //elimin toate spatiile
   {
      while (E[i] != ' ' && i < strlen(E)) i++;
      if (i < strlen(E))
      {
         strcpy(E + i, E + i + 1);
         i--;
      }
   }
   char x = E[0];             //retin variabila in care se va memora valoarea din dreapta
   strcpy(E, E + 2);          //elimin 'x='
   i = 0;                                //parcurg termen cu termen
   while (i < strlen(E))
   {
      coef = 0;                          //plec cu coef = 0
      while (E[i] >= '0' && E[i] <= '9') //formez coeficientul
      {
         coef = coef * 10 + E[i] - '0';
         i++;
      }                                  //am ajuns pe variabila sau pe semn
      if (E[i] >= 'a' && E[i] <= 'z')    //daca urmeaza variabila
      {
         if (coef == 0) coef = 1;        //daca coef a ramas pe 0  => este 1
         val_dreapta += semn * coef * V[E[i]-'a'];//adaug valoarea termenului la val_dreapta
         i++;                            //si trec pe semnul urmator
      }
      else
         val_dreapta += semn * coef;     //este doar o constanta ... o adaug la val_dreapta
      //sunt pe semnul urmator
      if (E[i] == '-')                   //daca e '-' schimb semnul
         semn = -1;
      else
         semn = 1;
      i++;                               //trec la termenul urmator
   }
   V[x-'a'] = val_dreapta;               //pun in x valoarea calculata in dreapta
}

void fa_repeat()
{
   char I[110];
   int nr_instr_rep = 0, repetari, i;
   int n = atoi(instructiune + 6);             //determin numarul de repetari
   fin.getline(instructiune, 110);             //citesc prima instructiune din REPETA
   while (instructiune[0] == ' ')              //elimin spatiile de la inceput
      strcpy(instructiune, instructiune + 1);
   while (strcmp(instructiune, "STOP") != 0)   //cat timp NU am citit instructiunea STOP
   {
      nr_instr_rep++;                                 //numara instructiunea
      strcpy(secv_repeat[nr_instr_rep], instructiune);//retine-o in secventa
      fin.getline(instructiune, 110);          //citesc instructiunea urmatoare
      while (instructiune[0] == ' ')           //elimin spatiile de la inceput
         strcpy(instructiune, instructiune + 1);
   }
   for (repetari = 1; repetari <= n; repetari++)//execut instructiune cu instructiune ciclul REPETA
      for (i = 1; i <= nr_instr_rep; i++)       //in acest ciclu pot fi doar
      {                                         //scrieri si =
         if (secv_repeat[i][0] == 'S')
            scrie(secv_repeat[i]);
         else
         {
            strcpy(I, secv_repeat[i]);          //transmit o copie ... se distruge
            expresie(I);
         }
      }
}

int main()
{
   fin >> cerinta; fin.get();
   fin.getline(instructiune, 110);              //INCEPE, sar peste ea
   while (fin.getline(instructiune, 110))       //cat timp mai am instructiuni de citit
   {
      while (instructiune[0] == ' ')            //elimin spatiile de la inceput
         strcpy(instructiune, instructiune + 1);
      if (instructiune[0] == 'R')               //este REPETA
         fa_repeat();
      else
         if (instructiune[0] == 'S' && instructiune[1] == 'C')
            scrie(instructiune);                //este SCRIE
         else
            expresie(instructiune);          //este '='
   }
   if (cerinta == 1)
      fout << contor_scrie << '\n';
   return 0;
}
